diff -Naur --exclude=CVS --exclude=configs linux/hpc/load.c linux-openmosix/hpc/load.c
--- linux/hpc/load.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/hpc/load.c	2004-04-06 21:19:38.000000000 +0200
@@ -0,0 +1,243 @@
+/* Changes since Feb 12, 2002 copyright by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * Author(s): Amnon Shiloh, Amnon Barak, Moshe Bar
+ */
+
+#include <linux/sched.h>
+#include <linux/hpcctl.h>
+#include <net/sock.h>
+#include <hpc/defs.h>
+#include <hpc/routines.h>
+#include <hpc/protocol.h>
+#include <linux/hpc.h>
+#include <asm/uaccess.h>
+#include <linux/smp_lock.h>
+#include <linux/swap.h>
+#include <linux/stddef.h>
+#include <hpc/balance.h>
+#include <linux/kernel_stat.h>
+
+#define VV1     5
+#define VV2     8
+#define DECAY   VV1/VV2         /* decay of load */
+#define NEWDATA (VV2-VV1)/VV2   /* weight of new load data */
+
+unsigned load_adder;    /* accumulator of `running' every clock tick */
+unsigned load_ticks;    /* # of ticks included in load_adder */
+unsigned cpuse;         /* # of ticks when CPU was not thrashing */
+unsigned acpuse = MF;   /* long term non-trashing (start value = non-0) */
+unsigned coming_in;     /* number of arriving processes */
+unsigned came_lately4;  /* processes that arrived lately (*4) */
+unsigned load_left;     /* load of processes that just left */
+
+int export_load;	/* load reported to other processors */
+int stable_export;	/* machine dependent stabilizing factor */
+
+int Tvis;
+int Tload;
+
+
+
+void
+mosix_calc_load(unsigned long unused)
+{
+	struct task_struct *p;
+	register struct mosix_task *m;
+	register int ladd, cpu, ticks;
+	unsigned long flags;
+	unsigned long newload;
+#ifdef CONFIG_MOSIX_LOADLIMIT
+	unsigned long loadremote, loadlocal, cpulocal, cpuremote;
+	int ii;
+#endif
+	int new_expload;
+	unsigned new_cpuse;
+	unsigned new_came;
+	static unsigned upper_load;    /* over estimated load */
+	static unsigned accload;       /* accumulated load (*128) */
+	static int display_counter = 0;
+#ifdef CONFIG_MOSIX_RESEARCH
+	unsigned int new_io_read;
+	unsigned int new_io_write;
+	unsigned int major;
+	unsigned int disk;
+#endif /* CONFIG_MOSIX_RESEARCH */
+
+	ticks = load_ticks;
+	cpu = cpuse;
+	ladd = load_adder;
+	cpuse = load_adder = load_ticks = 0;
+
+	ladd = ladd * ((long long)(MF * STD_SPD)) /
+		(ticks * cpuspeed * smp_num_cpus);
+	if(ladd * 128 > accload)	/* slowly up */
+		accload = accload * DECAY + ladd * 128 * NEWDATA;
+	else				/* quickly down */
+		accload = ladd * 128;
+	if(ladd >= upper_load)		/* quickly up */
+		upper_load = ladd;
+	else				/* very slowly down */
+		upper_load = (upper_load * 7 + ladd) / 8;
+	new_cpuse = (acpuse * 3 + cpu * MF / ticks + 3) / 4;
+	newload = (accload+64) / 128;
+	new_expload = (upper_load + stable_export +
+		came_lately4 * MF * STD_SPD /
+			(4 * cpuspeed * smp_num_cpus)) *
+			MF * smp_num_cpus / new_cpuse;
+	if(newload < load_left)
+		newload = 0;
+	else
+		newload -= load_left;
+	newload = newload * MF * smp_num_cpus / new_cpuse;
+	new_came = came_lately4 * DECAY + coming_in * 4 * NEWDATA;
+	spin_lock_irqsave(&runqueue_lock, flags);
+#ifdef CONFIG_MOSIX_LOADLIMIT
+	loadlocal = loadremote = cpulocal = cpuremote = 0;	
+#endif
+	for_each_task(p)
+	{
+		m = &p->mosix;
+		if(m->runstart)
+		{
+			m->ran += ticks + 1 - m->runstart;
+			m->runstart = 1;
+		}
+		m->load = m->load * DECAY + m->ran * MF * 4*NEWDATA/ticks;
+#ifdef CONFIG_MOSIX_LOADLIMIT
+		if (m->dflags & DREMOTE)
+		{
+			if (m->last_per_cpu_utime[0])
+			{
+				/* this means that at least one time we were already here */
+				for (ii = 0;  ii < smp_num_cpus; ii++)
+				{
+					cpuremote += p->per_cpu_utime[ii] - 
+					m->last_per_cpu_utime[ii];
+					cpuremote += p->per_cpu_stime[ii] -
+					m->last_per_cpu_stime[ii];
+				}
+			}
+			loadremote += m->load; 
+		}
+		else
+		{
+			if (m->last_per_cpu_utime[0])
+			{
+				for (ii = 0 ; ii < smp_num_cpus; ii++)
+				{
+					cpulocal += p->per_cpu_utime[ii] - 
+					m->last_per_cpu_utime[ii];
+					cpulocal += p->per_cpu_stime[ii] - 
+					m->last_per_cpu_stime[ii];
+				}
+			}
+		    loadlocal += m->load;
+		}
+		for (ii = 0;  ii < smp_num_cpus; ii++)
+		{
+			m->last_per_cpu_utime[ii] = p->per_cpu_utime[ii];
+			m->last_per_cpu_stime[ii] = p->per_cpu_stime[ii]; 
+		}
+#endif
+		m->ran = 0;
+		m->page_allocs >>= 1;	/* decay in time */
+	}
+	spin_unlock_irqrestore(&runqueue_lock, flags);
+
+	if(Tvis)
+		printk("\0337\033[22;55HL=%d,E=%d,R=%d,U=%d  \0338",
+			(int)newload, new_expload, mosix_running,
+			new_cpuse);
+	if(Tload) {
+		if (!(display_counter = (display_counter + 1) & 0xf))
+			printk("\naccload upper_load\tload_adder\tload_ticks\n");
+		printk("%7d\t%10d\t%10d\t%d\n",
+			accload, upper_load, ladd, ticks);
+	}
+	write_lock(&loadinfo_lock);
+	loadinfo[0].load = newload;
+#ifdef CONFIG_MOSIX_LOADLIMIT
+	loadinfo[0].loadremote = loadremote;
+	loadinfo[0].loadlocal = loadlocal;
+	loadinfo[0].cpulocal = cpulocal*MF / ticks;
+	loadinfo[0].cpuremote = cpuremote*MF / ticks;
+#endif
+	export_load = new_expload;
+	acpuse = new_cpuse;
+	came_lately4 = new_came;
+	load_left = 0;
+
+	write_unlock(&loadinfo_lock);
+
+	if((p = (struct task_struct *)info_proc))
+		send_sig(SIGALRM, p, 1);
+}
+
+void
+mosix_load_init(void)
+{
+	acpuse = MF * smp_num_cpus;
+	load_ticks = MF;	/* fake it to begin with (must be non-zero) */
+	cpuse = MF * smp_num_cpus;
+	load_adder = mosix_running * MF;
+	mosix_calc_load(0);
+#ifdef CONFIG_MOSIX_LOADLIMIT
+	loadinfo[0].load_limit = 0;
+	loadinfo[0].llimitmode = 0;
+	loadinfo[0].cpu_limit = 0;
+	loadinfo[0].cpulimitmode = 0;
+	loadinfo[0].cpulocal = 0;
+	loadinfo[0].cpuremote = 0;
+	loadinfo[0].loadlocal = 0;
+	loadinfo[0].loadremote = 0;
+#else
+	loadinfo[0].load_limit = 0; 
+	loadinfo[0].llimitmode = 255;/* 255 = no load limit */
+	loadinfo[0].cpu_limit = 0;
+	loadinfo[0].cpulimitmode = 255;
+	loadinfo[0].cpulocal = 0;
+	loadinfo[0].cpuremote = 0;
+	loadinfo[0].loadlocal = 0;
+	loadinfo[0].loadremote = 0;
+#endif
+}
+
+void
+mosix_snap_load(int ticks)
+{
+	unsigned long flags;
+	extern struct list_head runqueue_head;
+
+	load_adder += mosix_running;
+	if(mosix_running <= active_cpus)
+		cpuse += ticks * smp_num_cpus;
+	else
+	{
+		/* a possible race between the time of making a process runable
+		 * and actual picking up by a processor: so count runable
+		 * processes as if already occupying a processor:
+		 */
+		int n;
+		register struct task_struct *p;
+		struct list_head *tmp;
+
+		spin_lock_irqsave(&runqueue_lock, flags);
+		if((n = active_cpus) < smp_num_cpus)
+		for(tmp = runqueue_head.next ; tmp != &runqueue_head ;
+								tmp = tmp->next)
+		{
+			p = list_entry(tmp, struct task_struct, run_list);
+			if(p->mosix.runstart && ++n == smp_num_cpus)
+				break;
+		}
+		spin_unlock_irqrestore(&runqueue_lock, flags);
+		cpuse += ticks * n;
+	}
+	load_ticks += ticks;
+	if(load_ticks >= MF)
+		mosix_calc_load(0);
+}
diff -Naur --exclude=CVS --exclude=configs linux/hpc/Makefile linux-openmosix/hpc/Makefile
--- linux/hpc/Makefile	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/hpc/Makefile	2003-07-13 14:26:02.000000000 +0200
@@ -0,0 +1,38 @@
+#
+# Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+#
+# Permission to use this software is hereby granted under the terms of the
+# GNU General Public License, as published by the Free Software Foundation.
+#
+# THIS  SOFTWARE  IS  PROVIDED IN ITS  "AS IS"  CONDITION, WITH NO WARRANTY
+# WHATSOEVER. NO LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING
+# FROM THE USE OF THIS SOFTWARE WILL BE ACCEPTED.
+#
+#
+# Makefile for HPC permanent interface.
+#
+# Note! Dependencies are done automagically by 'make dep', which also
+# removes any old dependencies. DON'T put your own dependencies here
+# unless it's something special (ie not a .c file).
+#
+
+O_TARGET := hpc.o
+obj-y    := alternate.o auto_syscalls.o balance.o comm.o config.o decay.o \
+	    deputy.o div.o export.o freemem.o init.o info.o kernel.o load.o \
+	    mig.o hpcadmin.o hpcproc.o prequest.o remote.o rinode.o \
+	    service.o syscalls.o ucache.o badops.o
+
+obj-$(CONFIG_MOSIX_DFSA) += dfsa.o
+
+export-objs = export.o
+
+include $(TOPDIR)/Rules.make
+
+auto_syscalls.c: mkdefcalls $(TOPDIR)/arch/i386/kernel/entry.S syscalls.c
+	./mkdefcalls
+
+mkdefcalls: mkdefcalls.c $(TOPDIR)/include/linux/config.h $(TOPDIR)/include/linux/types.h $(TOPDIR)/include/linux/sched.h $(TOPDIR)/include/linux/signal.h $(TOPDIR)/include/linux/sys.h $(TOPDIR)/include/linux/kernel.h
+	$(HOSTCC) $(HOSTCFLAGS) -I$(HPATH) -o mkdefcalls -DENTRY_IN=\"$(TOPDIR)/arch/i386/kernel/entry.S\" -DSYSCALLS_IN=\"$(TOPDIR)/hpc/syscalls.c\" -DSYSCALLS_OUT=\"$(TOPDIR)/hpc/auto_syscalls.c\" mkdefcalls.c
+
+alternate.c: copy_unconf $(TOPDIR)/fs/binfmt_aout.c $(TOPDIR)/.config
+	/bin/sh ./copy_unconf "$(CONFIG_BINFMT_AOUT)" $(TOPDIR)/fs/binfmt_aout.c > alternate.c
